#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <termio.h>
#include <sys/termios.h>


#define DEFAULTPORT "5678"


extern int debug;
extern char inifile[];

/* define global variables */
static int ttyfd = -1;
static struct termio ttyset;

int serial_open()
{
    char temp[255];
    char *p;
    int err;

    GetPrivateProfileString("device", "port", "/dev/ttyS0", temp, 128, inifile);

    if (p = strchr(temp, ':')) {
	char *port = DEFAULTPORT;
	int one = 1;

	if (*(p + 1))
	    port = p + 1;
	*p = '\0';

	//temp now holds the HOSTNAME portion and port the port number.
	if (debug > 5)
	    fprintf(stderr, "Host: %s  Port: %s\n", temp, port);
	ttyfd = connectTCP(temp, port);
	setsockopt(ttyfd, SOL_SOCKET, SO_REUSEADDR, (char *) &one, sizeof(one));

	if (write(ttyfd, "r\n", 2) != 2)
	    errexit("Can't write to socket");
    } else {
	ttyfd = open(temp, O_RDWR | O_NONBLOCK);
	if (ttyfd < 0)
	    return (-1);

	if (isatty(ttyfd)) {
	    if (ioctl(ttyfd, TCGETA, &ttyset) < 0)
		return (-1);

	    ttyset.c_cflag = CBAUD & B4800;
	    ttyset.c_cflag |= (CSIZE & CS8) | CREAD;
	    ttyset.c_iflag = ttyset.c_oflag = ttyset.c_lflag = (ushort) 0;
	    ttyset.c_oflag = (ONLRET);
	    if (ioctl(ttyfd, TCSETAF, &ttyset) < 0)
		return (-1);
	}
    }
    return ttyfd;
}

/****************************************************************************/
/* Close serial device.                                                     */
/****************************************************************************/
void serial_close()
{
    if (ttyfd != -1) {
	if (isatty(ttyfd)) {
	    ttyset.c_cflag = CBAUD & B0;
	    ioctl(ttyfd, TCSETAF, &ttyset);
	}
	close(ttyfd);
	ttyfd = -1;
    }
}
